## runc 1.0.3+ds1

=== debian/changelog ===
runc (1.0.3+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.0.3+ds1
    + CVE-2021-43784: Overflow in netlink bytemsg length field allows
      attacker to override netlink-based container configuration
  * Remove unused lintian override spare-manual-page

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 06 Dec 2021 15:59:43 +0800

runc (1.0.2+ds1-2) unstable; urgency=medium

  * Team upload.
  * Bump golang-github-checkpoint-restore-go-criu-dev to 5.1.0
  * Drop golang-github-willf-bitset-dev from Depends
  * Remove compatible patch for podman

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 11 Oct 2021 01:12:21 +0800

runc (1.0.2+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.0.2+ds1
  * Bump golang-github-coreos-go-systemd-dev to 22.3.2

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 23 Aug 2021 19:02:58 +0800

=== debian/control ===
Source: runc
Section: admin
Priority: optional
Standards-Version: 4.6.0
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Alexandre Viau <aviau@debian.org>,
           Dmitry Smirnov <onlyjob@debian.org>,
           Tim Potter <tpot@hpe.com>,
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               go-md2man,
               golang-any,
               golang-dbus-dev,
               golang-github-checkpoint-restore-go-criu-dev (>= 5.1.0~),
               golang-github-cilium-ebpf-dev (>= 0.6.2~),
               golang-github-containerd-console-dev,
               golang-github-coreos-go-systemd-dev (>= 22.3.2~),
               golang-github-cpuguy83-go-md2man-v2-dev,
               golang-github-cyphar-filepath-securejoin-dev,
               golang-github-docker-go-units-dev (>= 0.4.0~),
               golang-github-moby-sys-dev (>= 0.0~git20201113.5a29239~),
               golang-github-mrunalp-fileutils-dev,
               golang-github-opencontainers-selinux-dev (>= 1.8.0~),
               golang-github-opencontainers-specs-dev (>= 1.0.2.66~),
               golang-github-pkg-errors-dev (>= 0.9.1~),
               golang-github-seccomp-libseccomp-golang-dev (>= 0.9.1~),
               golang-github-sirupsen-logrus-dev (>= 1.0.2~),
               golang-github-vishvananda-netlink-dev,
               golang-gocapability-dev (>= 0.0+git20200815~),
               golang-golang-x-net-dev,
               golang-goprotobuf-dev,
Homepage: https://github.com/opencontainers/runc
Vcs-Git: https://salsa.debian.org/go-team/packages/runc.git
Vcs-Browser: https://salsa.debian.org/go-team/packages/runc
XS-Go-Import-Path: github.com/opencontainers/runc
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-go

Package: runc
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Breaks: docker.io (<= 1.13.1~ds1-2),
Built-Using: ${misc:Built-Using},
Recommends: criu,
            ${misc:Recommends},
Description: Open Container Project - runtime
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.

Package: golang-github-opencontainers-runc-dev
Architecture: all
Section: golang
Depends: golang-dbus-dev,
         golang-github-checkpoint-restore-go-criu-dev (>= 5.1.0~),
         golang-github-cilium-ebpf-dev (>= 0.6.2~),
         golang-github-containerd-console-dev,
         golang-github-coreos-go-systemd-dev (>= 22.3.2~),
         golang-github-cyphar-filepath-securejoin-dev,
         golang-github-docker-go-units-dev (>= 0.4.0~),
         golang-github-moby-sys-dev (>= 0.0~git20201113.5a29239~),
         golang-github-mrunalp-fileutils-dev,
         golang-github-opencontainers-selinux-dev (>= 1.8.0~),
         golang-github-opencontainers-specs-dev (>= 1.0.2.66~),
         golang-github-pkg-errors-dev (>= 0.9.1~),
         golang-github-seccomp-libseccomp-golang-dev (>= 0.9.1~),
         golang-github-sirupsen-logrus-dev (>= 1.0.2~),
         golang-github-vishvananda-netlink-dev,
         golang-gocapability-dev (>= 0.0+git20200815~),
         golang-golang-x-net-dev,
         golang-goprotobuf-dev,
         ${misc:Depends},
Breaks: podman (<< 2.0.4+dfsg2-5~),
Description: Open Container Project - development files
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.
 .
 This package provides development files formerly known as
 "github.com/docker/libcontainer".

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_GOLANG_EXCLUDES      := libcontainer/integration contrib/cmd

TAGS    := seccomp
LDFLAGS := -X main.version=$(DEB_VERSION_UPSTREAM) -X main.gitCommit=$(DEB_VERSION)

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

execute_after_dh_auto_configure:
	# local copy of urfave/cli, https://github.com/urfave/cli/issues/1092
	cp -vr debian/vendor _build/src/github.com/opencontainers/runc/

execute_after_dh_auto_build:
	cd man && ./md2man-all.sh

override_dh_auto_build:
	dh_auto_build -- -tags "$(TAGS)" -ldflags "$(LDFLAGS)"

override_dh_auto_test:
	dh_auto_test -- -tags "$(TAGS)"

=== debian/tests/control ===
Tests: integration
Architecture: amd64 arm64
Depends: bats,
         build-essential,
         ca-certificates,
         curl,
         gawk,
         git,
         golang-any,
         jq,
         runc,
# remove flaky when debci.d.n has well cgroupv2 support
Restrictions: allow-stderr, needs-root, needs-internet, isolation-container, flaky

## runc 1.1.0

=== debian/changelog ===
runc (1.1.0-0ubuntu1~18.04.1) bionic; urgency=medium

  * Backport version 1.1.0-0ubuntu1 from Jammy (LP: #1960449).
    - Build with Golang 1.16
      + d/control: b-d on golang-1.16-go instead of golang-any.
      + d/rules: add Golang 1.16 to $PATH.
    - d/rules: set GO111MODULE to off, to avoid Internet connection during the
      build.
    - d/rules: set GOCACHE to build directory.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Thu, 31 Mar 2022 16:03:03 -0300

runc (1.1.0-0ubuntu1) jammy; urgency=medium

  * New upstream release.
  * Refresh patches:
    - d/p/test--skip_TestFactoryNewTmpfs.patch
    - d/p/test--skip-fs-related-cgroups-tests.patch
  * Remove patch not needed anymore:
    - d/p/test--skip-Hugetlb.patch

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Wed, 09 Feb 2022 11:46:31 -0300

runc (1.0.3-0ubuntu1) jammy; urgency=medium

  * New upstream release (LP: #1946899).
  * d/rules: remove DH_GOLANG_INSTALL_EXTRA, the directories listed there do
    not exist anymore.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Mon, 10 Jan 2022 11:51:10 -0300

=== debian/control ===
Source: runc
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Alexandre Viau <aviau@debian.org>,
           Dmitry Smirnov <onlyjob@debian.org>,
           Tim Potter <tpot@hpe.com>
Build-Depends: debhelper (>= 11~),
               dh-golang,
               go-md2man,
               golang-1.16-go,
               libapparmor-dev,
               libseccomp-dev,
               pkg-config,
               protobuf-compiler
Standards-Version: 4.1.4
Homepage: https://github.com/opencontainers/runc
Vcs-Git: https://github.com/tianon/debian-runc.git -b ubuntu
Vcs-Browser: https://github.com/tianon/debian-runc/tree/ubuntu
XS-Go-Import-Path: github.com/opencontainers/runc

Package: runc
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Breaks: docker.io (<= 1.13.1~ds1-2)
Built-Using: ${misc:Built-Using}
Description: Open Container Project - runtime
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.

Package: golang-github-opencontainers-runc-dev
Architecture: all
Depends: ${misc:Depends}
Description: Open Container Project - development files
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.
 .
 This package provides development files formerly known as
 "github.com/docker/libcontainer".

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_GOPKG := github.com/opencontainers/runc
TAGS=apparmor seccomp selinux ambient
VERSION=$(shell dpkg-parsechangelog -SVersion)

# Build with Golang 1.16
export PATH := /usr/lib/go-1.16/bin:$(PATH)

export GO111MODULE := off
export GOCACHE := $(CURDIR)/.cache

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_auto_configure:
	cd man && ./md2man-all.sh
	dh_auto_configure
	## Remove extra license files:
	$(RM) -v \
            _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/*/*/LICENSE* \
        ;

override_dh_auto_build:
	dh_auto_build -- -tags "$(TAGS)" -ldflags "-X main.version=$(VERSION)"

override_dh_auto_test:
	DH_GOLANG_EXCLUDES="libcontainer/integration" \
        dh_auto_test -- -tags "$(TAGS)"

## runc 1.1.2

=== debian/changelog ===
runc (1.1.2-0ubuntu1) kinetic; urgency=medium

  * New upstream release.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Thu, 12 May 2022 16:15:38 -0300

## runc 1.1.3+ds1

=== debian/changelog ===
runc (1.1.3+ds1-2) unstable; urgency=medium

  * Team upload.
  * Revert "Vendor github.com/urfave/cli v1.22.1"
    Regression in github.com/urfave/cli is fixed in v1.22.9

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 16 Jun 2022 23:52:25 +0800

runc (1.1.3+ds1-1) unstable; urgency=medium

  * Team upload.

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster
    * Build-Depends: Drop versioned constraint on
      golang-github-sirupsen-logrus-dev.
    * runc: Drop versioned constraint on docker.io in Breaks.
    * golang-github-opencontainers-runc-dev: Drop versioned constraint on
      golang-github-sirupsen-logrus-dev in Depends.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.

  [ Shengjing Zhu ]
  * New upstream version 1.1.3+ds1
    * (1.1.2) CVE-2022-29162: Default inheritable capabilities for linux
      container should be empty
  * Bump golang-github-seccomp-libseccomp-golang-dev to 0.10.0
  * Update Standards-Version to 4.6.1 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 14 Jun 2022 03:46:31 +0800

runc (1.1.1+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.1.1+ds1

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 29 Mar 2022 12:00:14 +0800

runc (1.1.0+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.1.0+ds1
  * Upload to unstable
  * Enable seccomp integration test

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 07 Feb 2022 01:15:00 +0800

runc (1.1.0~rc.1+ds1-1) experimental; urgency=medium

  * Team upload.
  * New upstream version 1.1.0~rc.1+ds1
  * Disable seccomp notify to build with libseccomp-golang 0.9.1

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 15 Dec 2021 00:58:10 +0800

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_GOLANG_EXCLUDES      := libcontainer/integration contrib/cmd

TAGS    := seccomp
LDFLAGS := -X main.version=$(DEB_VERSION_UPSTREAM) -X main.gitCommit=$(DEB_VERSION)

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

execute_after_dh_auto_build:
	cd man && ./md2man-all.sh

override_dh_auto_build:
	dh_auto_build -- -tags "$(TAGS)" -ldflags "$(LDFLAGS)"

override_dh_auto_test:
	dh_auto_test -- -tags "$(TAGS)"

=== debian/tests/control ===
--- 
+++ 
@@ -8,6 +8,8 @@
          git,
          golang-any,
          jq,
+         libseccomp-dev,
+         pkgconf,
          runc,
 # remove flaky when debci.d.n has well cgroupv2 support
 Restrictions: allow-stderr, needs-root, needs-internet, isolation-container, flaky

## runc 1.1.4

=== Makefile ===
CONTAINER_ENGINE := docker
GO ?= go

PREFIX ?= /usr/local
BINDIR := $(PREFIX)/sbin
MANDIR := $(PREFIX)/share/man

GIT_BRANCH := $(shell git rev-parse --abbrev-ref HEAD 2>/dev/null)
GIT_BRANCH_CLEAN := $(shell echo $(GIT_BRANCH) | sed -e "s/[^[:alnum:]]/-/g")
RUNC_IMAGE := runc_dev$(if $(GIT_BRANCH_CLEAN),:$(GIT_BRANCH_CLEAN))
PROJECT := github.com/opencontainers/runc
BUILDTAGS ?= seccomp
COMMIT ?= $(shell git describe --dirty --long --always)
VERSION := $(shell cat ./VERSION)

ifeq ($(shell $(GO) env GOOS),linux)
	ifeq (,$(filter $(shell $(GO) env GOARCH),mips mipsle mips64 mips64le ppc64))
		ifeq (,$(findstring -race,$(EXTRA_FLAGS)))
			GO_BUILDMODE := "-buildmode=pie"
		endif
	endif
endif
GO_BUILD := $(GO) build -trimpath $(GO_BUILDMODE) $(EXTRA_FLAGS) -tags "$(BUILDTAGS)" \
	-ldflags "-X main.gitCommit=$(COMMIT) -X main.version=$(VERSION) $(EXTRA_LDFLAGS)"
GO_BUILD_STATIC := CGO_ENABLED=1 $(GO) build -trimpath $(EXTRA_FLAGS) -tags "$(BUILDTAGS) netgo osusergo" \
	-ldflags "-extldflags -static -X main.gitCommit=$(COMMIT) -X main.version=$(VERSION) $(EXTRA_LDFLAGS)"

GPG_KEYID ?= asarai@suse.de

.DEFAULT: runc

runc:
	$(GO_BUILD) -o runc .

all: runc recvtty sd-helper seccompagent

recvtty sd-helper seccompagent:
	$(GO_BUILD) -o contrib/cmd/$@/$@ ./contrib/cmd/$@

static:
	$(GO_BUILD_STATIC) -o runc .

releaseall: RELEASE_ARGS := "-a arm64 -a armel -a armhf -a ppc64le -a s390x"
releaseall: release

release: runcimage
	$(CONTAINER_ENGINE) run $(CONTAINER_ENGINE_RUN_FLAGS) \
		--rm -v $(CURDIR):/go/src/$(PROJECT) \
		-e RELEASE_ARGS=$(RELEASE_ARGS) \
		$(RUNC_IMAGE) make localrelease
	script/release_sign.sh -S $(GPG_KEYID) -r release/$(VERSION) -v $(VERSION)

localrelease:
	script/release_build.sh -r release/$(VERSION) -v $(VERSION) $(RELEASE_ARGS)

dbuild: runcimage
	$(CONTAINER_ENGINE) run $(CONTAINER_ENGINE_RUN_FLAGS) \
		--privileged --rm \
		-v $(CURDIR):/go/src/$(PROJECT) \
		$(RUNC_IMAGE) make clean all

lint:
	golangci-lint run ./...

man:
	man/md2man-all.sh

runcimage:
	$(CONTAINER_ENGINE) build $(CONTAINER_ENGINE_BUILD_FLAGS) -t $(RUNC_IMAGE) .

test: unittest integration rootlessintegration

localtest: localunittest localintegration localrootlessintegration

unittest: runcimage
	$(CONTAINER_ENGINE) run $(CONTAINER_ENGINE_RUN_FLAGS) \
		-t --privileged --rm \
		-v /lib/modules:/lib/modules:ro \
		-v $(CURDIR):/go/src/$(PROJECT) \
		$(RUNC_IMAGE) make localunittest TESTFLAGS=$(TESTFLAGS)

localunittest: all
	$(GO) test -timeout 3m -tags "$(BUILDTAGS)" $(TESTFLAGS) -v ./...

integration: runcimage
	$(CONTAINER_ENGINE) run $(CONTAINER_ENGINE_RUN_FLAGS) \
		-t --privileged --rm \
		-v /lib/modules:/lib/modules:ro \
		-v $(CURDIR):/go/src/$(PROJECT) \
		$(RUNC_IMAGE) make localintegration TESTPATH=$(TESTPATH)

localintegration: all
	bats -t tests/integration$(TESTPATH)

rootlessintegration: runcimage
	$(CONTAINER_ENGINE) run $(CONTAINER_ENGINE_RUN_FLAGS) \
		-t --privileged --rm \
		-v $(CURDIR):/go/src/$(PROJECT) \
		-e ROOTLESS_TESTPATH \
		$(RUNC_IMAGE) make localrootlessintegration

localrootlessintegration: all
	tests/rootless.sh

shell: runcimage
	$(CONTAINER_ENGINE) run $(CONTAINER_ENGINE_RUN_FLAGS) \
		-ti --privileged --rm \
		-v $(CURDIR):/go/src/$(PROJECT) \
		$(RUNC_IMAGE) bash

install:
	install -D -m0755 runc $(DESTDIR)$(BINDIR)/runc

install-bash:
	install -D -m0644 contrib/completions/bash/runc $(DESTDIR)$(PREFIX)/share/bash-completion/completions/runc

install-man: man
	install -d -m 755 $(DESTDIR)$(MANDIR)/man8
	install -D -m 644 man/man8/*.8 $(DESTDIR)$(MANDIR)/man8

clean:
	rm -f runc runc-*
	rm -f contrib/cmd/recvtty/recvtty
	rm -f contrib/cmd/sd-helper/sd-helper
	rm -f contrib/cmd/seccompagent/seccompagent
	rm -rf release
	rm -rf man/man8

cfmt: C_SRC=$(shell git ls-files '*.c' | grep -v '^vendor/')
cfmt:
	indent -linux -l120 -il0 -ppi2 -cp1 -T size_t -T jmp_buf $(C_SRC)

shellcheck:
	shellcheck tests/integration/*.bats tests/integration/*.sh \
		tests/integration/*.bash tests/*.sh \
		script/release_*.sh script/seccomp.sh script/lib.sh
	# TODO: add shellcheck for more sh files

shfmt:
	shfmt -ln bats -d -w tests/integration/*.bats
	shfmt -ln bash -d -w man/*.sh script/* tests/*.sh tests/integration/*.bash

vendor:
	$(GO) mod tidy
	$(GO) mod vendor
	$(GO) mod verify

verify-changelog:
	# No non-ASCII characters.
	! LC_ALL=C grep -n -P '[\x80-\xFF]' CHANGELOG.md
	# No space at EOL.
	! grep -n '\s$$' CHANGELOG.md
	# Period before issue/PR references.
	! grep -n '[0-9a-zA-Z][^.] (#[1-9][0-9, #]*)$$' CHANGELOG.md

verify-dependencies: vendor
	@test -z "$$(git status --porcelain -- go.mod go.sum vendor/)" \
		|| (echo -e "git status:\n $$(git status -- go.mod go.sum vendor/)\nerror: vendor/, go.mod and/or go.sum not up to date. Run \"make vendor\" to update"; exit 1) \
		&& echo "all vendor files are up to date."

.PHONY: runc all recvtty sd-helper seccompagent static releaseall release \
	localrelease dbuild lint man runcimage \
	test localtest unittest localunittest integration localintegration \
	rootlessintegration localrootlessintegration shell install install-bash \
	install-man clean cfmt shfmt shellcheck \
	vendor verify-changelog verify-dependencies

=== debian/changelog ===
runc (1.1.4-0ubuntu1~18.04.2) bionic-security; urgency=medium

  * d/p/lp2013318-fix-device-files-in-containers.patch: Fix inability to use
    device files such as /dev/null in containers (LP: #2013318)
  * SECURITY UPDATE: Incorrect access control through /sys/fs/cgroup
    - debian/patches/CVE-2023-25809.patch: apply MS_RDONLY if
      /sys/fs/cgroup is bind-mounted or mask if bind source is unavailable
      in libcontainer/rootfs_linux.go.
    - CVE-2023-25809
  * SECURITY UPDATE: Incorrect access control through /proc and /sys
    - debian/patches/CVE-2023-27561_2023-28642.patch: Prohibit /proc and
      /sys to be symlinks in libcontainer/rootfs_linux.go.
    - CVE-2023-27561
    - CVE-2023-28642

 -- David Fernandez Gonzalez <david.fernandezgonzalez@canonical.com>  Tue, 16 May 2023 12:07:05 +0200

runc (1.1.4-0ubuntu1~18.04.1) bionic; urgency=medium

  * Backport version 1.1.4-0ubuntu1 from Lunar (LP: #1996909).
    - d/control: b-d on golang-1.18-go instead of golang-any.
    - d/rules: build with Golang 1.18.
    - d/rules: set GO111MODULE to off.
    - d/rules: set GOCACHE.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Thu, 17 Nov 2022 14:05:31 -0300

runc (1.1.4-0ubuntu1) lunar; urgency=medium

  * New upstream release (LP: #1993442).
  * Refresh patches.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Wed, 16 Nov 2022 11:59:36 -0300

runc (1.1.2-0ubuntu1.1) kinetic; urgency=medium

  * d/p/fix_cpuset_range_byte_order.patch: fix byte order while parsing cpuset
    range to bits (LP: #1993221)

 -- Chengen Du <chengen.du@canonical.com>  Mon, 17 Oct 2022 15:59:43 +0800

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Build-Depends: debhelper (>= 11~),
                dh-golang,
                go-md2man,
-               golang-1.16-go,
+               golang-1.18-go,
                libapparmor-dev,
                libseccomp-dev,
                pkg-config,

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_GOPKG := github.com/opencontainers/runc
TAGS=apparmor seccomp selinux ambient
VERSION=$(shell dpkg-parsechangelog -SVersion)

# Build with Golang 1.18
export PATH := /usr/lib/go-1.18/bin:$(PATH)

export GO111MODULE := off
export GOCACHE := $(CURDIR)/.cache

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_auto_configure:
	cd man && ./md2man-all.sh
	dh_auto_configure
	## Remove extra license files:
	$(RM) -v \
            _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/*/*/LICENSE* \
        ;

override_dh_auto_build:
	dh_auto_build -- -tags "$(TAGS)" -ldflags "-X main.version=$(VERSION)"

override_dh_auto_test:
	DH_GOLANG_EXCLUDES="libcontainer/integration" \
        dh_auto_test -- -tags "$(TAGS)"

=== debian/tests/control ===
Tests: basic-smoke
Depends: busybox-static, @
Restrictions: allow-stderr, isolation-machine, needs-root

Test-Command: /usr/bin/dh_golang_autopkgtest
Depends: @, @builddeps@, dh-golang
Restrictions: allow-stderr, isolation-machine

## runc 1.1.4+ds1

=== debian/changelog ===
runc (1.1.4+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.1.4+ds1

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 27 Aug 2022 18:27:50 +0800

runc (1.1.3+ds1-7) unstable; urgency=medium

  * Team upload.
  * Mark the integration autopkgtest flaky again, needs more investigation on arm

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 17 Aug 2022 19:12:58 +0200

runc (1.1.3+ds1-6) unstable; urgency=medium

  * Team upload.
  * backport upstream commit c0be1aa2d101dcd3074b5a0e486d58d3f9568d81
    required for podman 4.2
  * Merge with upload to experimental

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 17 Aug 2022 18:45:35 +0200

runc (1.1.3+ds1-5) experimental; urgency=medium

  * Team upload.
  * Fix integration test on i386 and armhf
  * Enable integration on armel

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 05 Jul 2022 11:08:08 +0800

runc (1.1.3+ds1-4) experimental; urgency=medium

  * Fix seccomp integration tests again on arm
  * Build with urfave_cli_no_docs tag

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 04 Jul 2022 16:16:53 +0800

runc (1.1.3+ds1-3) experimental; urgency=medium

  * Fix seccomp integration tests on arm
  * Enable integration on armhf and i386 and remove flaky flag

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 20 Jun 2022 13:28:53 +0800

## runc 1.1.5+ds1

=== debian/changelog ===
runc (1.1.5+ds1-1+deb12u1) bookworm-security; urgency=high

  * Team upload.
  * CVE-2024-21626: several container breakouts due to internally leaked fds

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 02 Feb 2024 21:53:05 +0800

runc (1.1.5+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.1.5+ds1
    + CVE-2023-25809: rootless: `/sys/fs/cgroup` is writable when cgroupns
      isn't unshared
    + CVE-2023-27561: Incorrect Authorization vulnerability
      (re-introduced CVE-2019-19921) (Closes: #1033520)
    + CVE-2023-28642: AppArmor/SELinux bypass with symlinked /proc
  * Drop patches applied in new version
    - 0009-tests-replace-local-hello-world-bundle-with-busybox-.patch
    - 0010-tests-convert-arm32-arch-string-when-download-bundle.patch
  * Add patch to skip TestOpenat2 when cgroups is not available

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 29 Mar 2023 17:24:36 +0800

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_GOLANG_EXCLUDES      := libcontainer/integration contrib/cmd

TAGS    := seccomp urfave_cli_no_docs
LDFLAGS := -X main.version=$(DEB_VERSION_UPSTREAM) -X main.gitCommit=$(DEB_VERSION)

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

execute_after_dh_auto_build:
	cd man && ./md2man-all.sh

override_dh_auto_build:
	dh_auto_build -- -tags "$(TAGS)" -ldflags "$(LDFLAGS)"

override_dh_auto_test:
	dh_auto_test -- -tags "$(TAGS)"

=== debian/tests/control ===
Tests: integration
Architecture: amd64 arm64 armel armhf i386
Depends: bats,
         build-essential,
         ca-certificates,
         curl,
         gawk,
         git,
         golang-any,
         jq,
         libseccomp-dev,
         pkgconf,
         runc,
Restrictions: allow-stderr, needs-root, needs-internet, isolation-container, flaky

## runc 1.1.7

=== Makefile ===
--- 
+++ 
@@ -50,7 +50,7 @@
 		$(RUNC_IMAGE) make localrelease
 	script/release_sign.sh -S $(GPG_KEYID) -r release/$(VERSION) -v $(VERSION)
 
-localrelease:
+localrelease: verify-changelog
 	script/release_build.sh -r release/$(VERSION) -v $(VERSION) $(RELEASE_ARGS)
 
 dbuild: runcimage
@@ -133,12 +133,16 @@
 shellcheck:
 	shellcheck tests/integration/*.bats tests/integration/*.sh \
 		tests/integration/*.bash tests/*.sh \
-		script/release_*.sh script/seccomp.sh script/lib.sh
-	# TODO: add shellcheck for more sh files
+		man/*.sh script/*
+	# TODO: add shellcheck for more sh files (contrib/completions/bash/runc).
 
 shfmt:
-	shfmt -ln bats -d -w tests/integration/*.bats
-	shfmt -ln bash -d -w man/*.sh script/* tests/*.sh tests/integration/*.bash
+	$(CONTAINER_ENGINE) run $(CONTAINER_ENGINE_RUN_FLAGS) \
+		--rm -v $(CURDIR):/src -w /src \
+		mvdan/shfmt:v3.5.1 -d -w .
+
+localshfmt:
+	shfmt -d -w .
 
 vendor:
 	$(GO) mod tidy
@@ -146,8 +150,6 @@
 	$(GO) mod verify
 
 verify-changelog:
-	# No non-ASCII characters.
-	! LC_ALL=C grep -n -P '[\x80-\xFF]' CHANGELOG.md
 	# No space at EOL.
 	! grep -n '\s$$' CHANGELOG.md
 	# Period before issue/PR references.
@@ -158,9 +160,12 @@
 		|| (echo -e "git status:\n $$(git status -- go.mod go.sum vendor/)\nerror: vendor/, go.mod and/or go.sum not up to date. Run \"make vendor\" to update"; exit 1) \
 		&& echo "all vendor files are up to date."
 
+validate-keyring:
+	script/keyring_validate.sh
+
 .PHONY: runc all recvtty sd-helper seccompagent static releaseall release \
 	localrelease dbuild lint man runcimage \
 	test localtest unittest localunittest integration localintegration \
 	rootlessintegration localrootlessintegration shell install install-bash \
-	install-man clean cfmt shfmt shellcheck \
-	vendor verify-changelog verify-dependencies
+	install-man clean cfmt shfmt localshfmt shellcheck \
+	vendor verify-changelog verify-dependencies validate-keyring

=== debian/changelog ===
runc (1.1.7-0ubuntu1~22.04.6) jammy-security; urgency=medium

  * No change rebuild due to golang-1.22 update

 -- Evan Caville <evan.caville@canonical.com>  Thu, 19 Jun 2025 15:02:34 +1000

runc (1.1.7-0ubuntu1~22.04.5) jammy-security; urgency=medium

  * No change rebuild due to golang-1.21 update

 -- Nishit Majithia <nishit.majithia@canonical.com>  Wed, 10 Jul 2024 09:51:49 +0530

runc (1.1.7-0ubuntu1~22.04.4) jammy; urgency=medium

  * d/t/control: remove basic-smoke test since it depends on runc binary now
    provided by src:runc-app.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Mon, 06 May 2024 16:50:52 -0300

runc (1.1.7-0ubuntu1~22.04.3) jammy; urgency=medium

  * Do not provide the runc binary package anymore (LP: #2022390).
    The runc binary package is now provided by src:runc-app.
    - d/control: remove the containerd binary package paragraph.
    - d/containerd.*: remove all files related to the containerd binary
      package.
    - d/p/test--skip-fs-related-cgroups-tests.patch:
    - d/golang-github-opencontainers-runc-dev.install:

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Wed, 13 Mar 2024 18:07:43 -0300

runc (1.1.7-0ubuntu1~22.04.2) jammy-security; urgency=medium

  * SECURITY UPDATE: container escape vulnerability                        
    - d/p/0001-Fix-File-to-Close.patch: Fix File to Close                  
    - d/p/0002-init-verify-after-chdir-that-cwd-is-inside-the-conta.patch: 
      init: verify after chdir that cwd is inside the container            
    - d/p/0003-setns-init-do-explicit-lookup-of-execve-argument-ear.patch: 
      setns init: do explicit lookup of execve argument early              
    - d/p/0004-init-close-internal-fds-before-execve.patch: init: close    
      internal fds before execve                                           
    - d/p/0005-cgroup-plug-leaks-of-sys-fs-cgroup-handle.patch: cgroup:     
      plug leaks of /sys/fs/cgroup handle                                  
    - d/p/0006-libcontainer-mark-all-non-stdio-fds-O_CLOEXEC-before.patch: 
      ibcontainer: mark all non-stdio fds O_CLOEXEC before spawning init   
    - CVE-2024-21626

 -- Nishit Majithia <nishit.majithia@canonical.com>  Wed, 24 Jan 2024 16:40:36 +0530

runc (1.1.7-0ubuntu1~22.04.1) jammy; urgency=medium

  * Backport version from Mantic to Jammy (LP: #2023694).

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Fri, 30 Jun 2023 17:42:42 -0300

runc (1.1.7-0ubuntu1) mantic; urgency=medium

  * New upstream release (LP: #2018107).
    - Update patches in d/patches:
      + test--skip_TestFactoryNewTmpfs.patch: rename to
        test--skip-privileged-test-factory_linux_test.go.patch to follow the
        Debian patch. Also updated it accordingly to Debian.
      + test--skip-fs-related-cgroups-tests.patch: remove one skipped test,
        now it is part of the patch above.
      + fix_cpuset_range_byte_order.patch: removed, applied by upstream.
        [Applied in upstream version 1.1.7]
      + lp2013318-fix-device-files-in-containers.patch: removed, fixed by
        upstream.
        [Fixed in upstream version 1.1.7]
      + CVE-2023-25809.patch: removed, applied by upstream.
        [Applied in upstream version 1.1.7]
      + CVE-2023-27561_2023-28642.patch: removed, applied by upstream.
        [Applied in upstream version 1.1.7]
  * Bump debhelper compatibility level to 12. Now, that Bionic reached EOSS we
    can update it to level 12.
    - d/control: build depend on debhelper-compat (= 12) instead of debhelper.
    - d/compat: removed, not needed anymore.
  * d/control: remove unneeded Breaks statement for docker.io.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Mon, 12 Jun 2023 17:39:01 -0300

runc (1.1.4-0ubuntu4) mantic; urgency=medium

  * SECURITY UPDATE: Incorrect access control through /sys/fs/cgroup
    - debian/patches/CVE-2023-25809.patch: apply MS_RDONLY if
      /sys/fs/cgroup is bind-mounted or mask if bind source is unavailable
      in libcontainer/rootfs_linux.go.
    - CVE-2023-25809
  * SECURITY UPDATE: Incorrect access control through /proc and /sys
    - debian/patches/CVE-2023-27561_2023-28642.patch: Prohibit /proc and
      /sys to be symlinks in libcontainer/rootfs_linux.go.
    - CVE-2023-27561
    - CVE-2023-28642

 -- David Fernandez Gonzalez <david.fernandezgonzalez@canonical.com>  Mon, 15 May 2023 13:20:53 +0200

runc (1.1.4-0ubuntu3) lunar; urgency=medium

  * d/p/lp2013318-fix-device-files-in-containers.patch: Fix inability to use
    device files such as /dev/null in containers (LP: #2013318)

 -- Lena Voytek <lena.voytek@canonical.com>  Thu, 06 Apr 2023 10:57:46 -0700

runc (1.1.4-0ubuntu2) lunar-proposed; urgency=medium

  * Import blockIODevice.patch from Debian (LP: #2009851)

 -- Reinhard Tartler <siretart@tauware.de>  Fri, 24 Mar 2023 19:05:09 -0400

=== debian/control ===
--- 
+++ 
@@ -6,10 +6,10 @@
 Uploaders: Alexandre Viau <aviau@debian.org>,
            Dmitry Smirnov <onlyjob@debian.org>,
            Tim Potter <tpot@hpe.com>
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 12),
                dh-golang,
                go-md2man,
-               golang-1.18-go,
+               golang-any,
                libapparmor-dev,
                libseccomp-dev,
                pkg-config,
@@ -19,16 +19,6 @@
 Vcs-Git: https://github.com/tianon/debian-runc.git -b ubuntu
 Vcs-Browser: https://github.com/tianon/debian-runc/tree/ubuntu
 XS-Go-Import-Path: github.com/opencontainers/runc
-
-Package: runc
-Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
-Breaks: docker.io (<= 1.13.1~ds1-2)
-Built-Using: ${misc:Built-Using}
-Description: Open Container Project - runtime
- "runc" is a command line client for running applications packaged according
- to the Open Container Format (OCF) and is a compliant implementation of
- the Open Container Project specification.
 
 Package: golang-github-opencontainers-runc-dev
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_GOPKG := github.com/opencontainers/runc
TAGS=apparmor seccomp selinux ambient
VERSION=$(shell dpkg-parsechangelog -SVersion)

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_auto_configure:
	cd man && ./md2man-all.sh
	dh_auto_configure
	## Remove extra license files:
	$(RM) -v \
            _build/src/$(DH_GOPKG)/vendor/github.com/docker/docker/*/*/LICENSE* \
        ;

override_dh_auto_build:
	dh_auto_build -- -tags "$(TAGS)" -ldflags "-X main.version=$(VERSION)"

override_dh_auto_test:
	DH_GOLANG_EXCLUDES="libcontainer/integration" \
        dh_auto_test -- -tags "$(TAGS)"

=== debian/tests/control ===
Test-Command: /usr/bin/dh_golang_autopkgtest
Depends: @, @builddeps@, dh-golang
Restrictions: allow-stderr, isolation-machine

## runc 1.1.10+ds1

=== debian/changelog ===
runc (1.1.10+ds1-1ubuntu1) noble; urgency=medium

  * Merge from Debian unstable (LP: #2022390). Make src:runc follow Debian and
    src:runc-app is going to ship the application with vendorized dependencies
    so we can keep updating just the application across all supported releases.
  * Added changes:
    - d/control: remove the binary paragraph for runc.
    - d/runc.*: remove all packaging related files associated to the
      runc binary package
    - d/tests/{checkpoint,integration}: remove since they depend on the
      runc binary package which is not provided by this source package
      anymore.
    - d/golang-github-opencontainers-runc-dev.install: remove this file, it
      is causing a FTBFS, no need to have it in place, the library files are
      already installed correctly without it.
    - d/rules: no need to generate manpages after build.
    - d/rules: remove runc binary from the binary package
    - d/golang-github-opencontainers-runc-dev.docs: install NOTICE file to
      be compliant with the Apache 2 license.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Thu, 11 Jan 2024 19:43:18 -0300

runc (1.1.10+ds1-1) unstable; urgency=medium

  * Team upload
  * New upstream version 1.1.10+ds1
  * Bump golang-github-mrunalp-fileutils-dev to 0.5.1
  * Move criu test to isolation-machine

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 05 Nov 2023 15:26:18 +0800

runc (1.1.5+ds1-5) unstable; urgency=medium

  * Team Upload
  * Rebuild against golang-github-urfave-cli_1.22.14-1, Closes: #1055059
  * Bug fix: "Fails to build source after successful build", thanks to
    Lucas Nussbaum, Closes: #1046528

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 31 Oct 2023 08:32:10 -0400

runc (1.1.5+ds1-4) unstable; urgency=medium

  * debian/tests/control: restrict criu dependency to amd64, arm64, armhf

 -- Reinhard Tartler <siretart@tauware.de>  Wed, 25 Oct 2023 18:09:09 -0400

runc (1.1.5+ds1-3) unstable; urgency=medium

  * Team upload
  * Bump standards version

 -- Reinhard Tartler <siretart@tauware.de>  Tue, 24 Oct 2023 18:14:00 -0400

runc (1.1.5+ds1-2) experimental; urgency=medium

  * Team upload.
  * compile against go-criu 6

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 22 Oct 2023 19:29:15 -0400

=== debian/control ===
Source: runc
Section: admin
Priority: optional
Standards-Version: 4.6.2
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Alexandre Viau <aviau@debian.org>,
           Dmitry Smirnov <onlyjob@debian.org>,
           Tim Potter <tpot@hpe.com>,
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               go-md2man,
               golang-any,
               golang-dbus-dev,
               golang-github-checkpoint-restore-go-criu-dev (>= 6),
               golang-github-cilium-ebpf-dev (>= 0.6.2~),
               golang-github-containerd-console-dev,
               golang-github-coreos-go-systemd-dev (>= 22.3.2~),
               golang-github-cyphar-filepath-securejoin-dev,
               golang-github-docker-go-units-dev (>= 0.4.0~),
               golang-github-moby-sys-dev (>= 0.0~git20201113.5a29239~),
               golang-github-mrunalp-fileutils-dev (>= 0.5.1~),
               golang-github-opencontainers-selinux-dev (>= 1.8.0~),
               golang-github-opencontainers-specs-dev (>= 1.0.2.66~),
               golang-github-seccomp-libseccomp-golang-dev (>= 0.10.0~),
               golang-github-sirupsen-logrus-dev,
               golang-github-urfave-cli-dev (>= 1.22.9~),
               golang-github-vishvananda-netlink-dev,
               golang-gocapability-dev (>= 0.0+git20200815~),
               golang-golang-x-net-dev,
               golang-google-protobuf-dev,
Homepage: https://github.com/opencontainers/runc
Vcs-Git: https://salsa.debian.org/go-team/packages/runc.git
Vcs-Browser: https://salsa.debian.org/go-team/packages/runc
XS-Go-Import-Path: github.com/opencontainers/runc
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-go

Package: golang-github-opencontainers-runc-dev
Architecture: all
Section: golang
Depends: golang-dbus-dev,
         golang-github-checkpoint-restore-go-criu-dev (>= 6),
         golang-github-cilium-ebpf-dev (>= 0.6.2~),
         golang-github-containerd-console-dev,
         golang-github-coreos-go-systemd-dev (>= 22.3.2~),
         golang-github-cyphar-filepath-securejoin-dev,
         golang-github-docker-go-units-dev (>= 0.4.0~),
         golang-github-moby-sys-dev (>= 0.0~git20201113.5a29239~),
         golang-github-mrunalp-fileutils-dev (>= 0.5.1~),
         golang-github-opencontainers-selinux-dev (>= 1.8.0~),
         golang-github-opencontainers-specs-dev (>= 1.0.2.66~),
         golang-github-seccomp-libseccomp-golang-dev (>= 0.10.0~),
         golang-github-sirupsen-logrus-dev,
         golang-github-urfave-cli-dev (>= 1.22.9~),
         golang-github-vishvananda-netlink-dev,
         golang-gocapability-dev (>= 0.0+git20200815~),
         golang-golang-x-net-dev,
         golang-google-protobuf-dev,
         ${misc:Depends},
Breaks: podman (<< 2.0.4+dfsg2-5~),
Description: Open Container Project - development files
 "runc" is a command line client for running applications packaged according
 to the Open Container Format (OCF) and is a compliant implementation of
 the Open Container Project specification.
 .
 This package provides development files formerly known as
 "github.com/docker/libcontainer".

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_GOLANG_EXCLUDES      := libcontainer/integration contrib/cmd

TAGS    := seccomp urfave_cli_no_docs
LDFLAGS := -X main.version=$(DEB_VERSION_UPSTREAM) -X main.gitCommit=$(DEB_VERSION)

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

execute_after_dh_auto_install:
	rm -rfv debian/golang-github-opencontainers-runc-dev/usr/bin

override_dh_auto_build:
	dh_auto_build -- -tags "$(TAGS)" -ldflags "$(LDFLAGS)"

override_dh_auto_test:
	dh_auto_test -- -tags "$(TAGS)"

## runc 1.1.12%2Bds1

=== debian/changelog ===
runc (1.1.12+ds1-2ubuntu1) noble; urgency=medium

  * Merge with Debian unstable (LP: #2060890). Remaining changes:
    - d/control: add non default pkg.runc.with-bin Build-Profiles to runc
      binary package.
    - d/golang-github-opencontainers-runc-dev.docs: install NOTICE file to be
      compliant with the Apache 2 license
    - d/tests/control: remove integration and checkpoint autopkgtest.
      Since they depend on the runc binary package which is not provided by
      this source package by default.
   * Dropped changes (replaced by non default Build-Profiles):
    - d/control: remove the binary paragraph for runc.
    - d/golang-github-opencontainers-runc-dev.install: remove this file, it
      is causing a FTBFS, no need to have it in place, the library files are
      already installed correctly without it.
    - d/runc.*: remove all packaging related files associated to the
      runc binary package
    - d/rules: no need to generate manpages after build
    - d/rules: remove runc binary from the binary package

 -- Shengjing Zhu <shengjing.zhu@canonical.com>  Tue, 02 Apr 2024 17:26:37 +0800

runc (1.1.12+ds1-2) unstable; urgency=medium

  * Team upload
  * Add pkgconf to Build-Depends

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 27 Feb 2024 18:01:32 +0800

runc (1.1.12+ds1-1ubuntu1) noble; urgency=medium

  * Merge with Debian unstable.
  * Remaining changes:
    - d/control: remove the binary paragraph for runc.
    - d/golang-github-opencontainers-runc-dev.docs: install NOTICE file to
      be compliant with the Apache 2 license.
    - d/golang-github-opencontainers-runc-dev.install: remove this file, it
      is causing a FTBFS, no need to have it in place, the library files are
      already installed correctly without it.
    - d/runc.*: remove all packaging related files associated to the
      runc binary package
    - d/rules: no need to generate manpages after build
    - d/rules: remove runc binary from the binary package
    - d/tests/{checkpoint,integration}: remove since they depend on the
      runc binary package which is not provided by this source package
      anymore
  * Dropped changes:
    - d/p/0001-Fix-File-to-Close.patch: Fix File to Close
    - d/p/0002-init-verify-after-chdir-that-cwd-is-inside-the-conta.patch:
      init: verify after chdir that cwd is inside the container
    - d/p/0003-setns-init-do-explicit-lookup-of-execve-argument-ear.patch:
      setns init: do explicit lookup of execve argument early
    - d/p/0004-init-close-internal-fds-before-execve.patch: init: close
      internal fds before execve
    - d/p/0005-cgroup-plug-leaks-of-sys-fs-cgroup-handle.patch: cgroup:
      plug leaks of /sys/fs/cgroup handle
    - d/p/0006-libcontainer-mark-all-non-stdio-fds-O_CLOEXEC-before.patch:
      ibcontainer: mark all non-stdio fds O_CLOEXEC before spawning init
    [ Incorporated by upstream. ]

 -- Nishit Majithia <nishit.majithia@canonical.com>  Wed, 07 Feb 2024 13:26:27 +0530

runc (1.1.12+ds1-1) unstable; urgency=medium

  * Team upload
  * New upstream version 1.1.12+ds1
    + CVE-2024-21626: several container breakouts due to internally leaked fds

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 02 Feb 2024 21:20:26 +0800

runc (1.1.10+ds1-1ubuntu2) noble; urgency=medium

  * SECURITY UPDATE: container escape vulnerability
    - d/p/0001-Fix-File-to-Close.patch: Fix File to Close
    - d/p/0002-init-verify-after-chdir-that-cwd-is-inside-the-conta.patch:
      init: verify after chdir that cwd is inside the container
    - d/p/0003-setns-init-do-explicit-lookup-of-execve-argument-ear.patch:
      setns init: do explicit lookup of execve argument early
    - d/p/0004-init-close-internal-fds-before-execve.patch: init: close
      internal fds before execve
    - d/p/0005-cgroup-plug-leaks-of-sys-fs-cgroup-handle.patch: cgroup:
      plug leaks of /sys/fs/cgroup handle
    - d/p/0006-libcontainer-mark-all-non-stdio-fds-O_CLOEXEC-before.patch:
      ibcontainer: mark all non-stdio fds O_CLOEXEC before spawning init
    - CVE-2024-21626

 -- Nishit Majithia <nishit.majithia@canonical.com>  Wed, 24 Jan 2024 16:41:53 +0530

## runc 1.1.12+ds1

=== Makefile ===
--- 
+++ 
@@ -10,22 +10,50 @@
 RUNC_IMAGE := runc_dev$(if $(GIT_BRANCH_CLEAN),:$(GIT_BRANCH_CLEAN))
 PROJECT := github.com/opencontainers/runc
 BUILDTAGS ?= seccomp
+
 COMMIT ?= $(shell git describe --dirty --long --always)
 VERSION := $(shell cat ./VERSION)
+LDFLAGS_COMMON := -X main.gitCommit=$(COMMIT) -X main.version=$(VERSION)
 
-ifeq ($(shell $(GO) env GOOS),linux)
-	ifeq (,$(filter $(shell $(GO) env GOARCH),mips mipsle mips64 mips64le ppc64))
-		ifeq (,$(findstring -race,$(EXTRA_FLAGS)))
-			GO_BUILDMODE := "-buildmode=pie"
-		endif
+GOARCH := $(shell $(GO) env GOARCH)
+
+GO_BUILDMODE :=
+# Enable dynamic PIE executables on supported platforms.
+ifneq (,$(filter $(GOARCH),386 amd64 arm arm64 ppc64le riscv64 s390x))
+	ifeq (,$(findstring -race,$(EXTRA_FLAGS)))
+		GO_BUILDMODE := "-buildmode=pie"
 	endif
 endif
-GO_BUILD := $(GO) build -trimpath $(GO_BUILDMODE) $(EXTRA_FLAGS) -tags "$(BUILDTAGS)" \
-	-ldflags "-X main.gitCommit=$(COMMIT) -X main.version=$(VERSION) $(EXTRA_LDFLAGS)"
-GO_BUILD_STATIC := CGO_ENABLED=1 $(GO) build -trimpath $(EXTRA_FLAGS) -tags "$(BUILDTAGS) netgo osusergo" \
-	-ldflags "-extldflags -static -X main.gitCommit=$(COMMIT) -X main.version=$(VERSION) $(EXTRA_LDFLAGS)"
+GO_BUILD := $(GO) build -trimpath $(GO_BUILDMODE) \
+	$(EXTRA_FLAGS) -tags "$(BUILDTAGS)" \
+	-ldflags "$(LDFLAGS_COMMON) $(EXTRA_LDFLAGS)"
+
+GO_BUILDMODE_STATIC :=
+LDFLAGS_STATIC := -extldflags -static
+# Enable static PIE executables on supported platforms.
+# This (among the other things) requires libc support (rcrt1.o), which seems
+# to be available only for arm64 and amd64 (Debian Bullseye).
+ifneq (,$(filter $(GOARCH),arm64 amd64))
+	ifeq (,$(findstring -race,$(EXTRA_FLAGS)))
+		GO_BUILDMODE_STATIC := -buildmode=pie
+		LDFLAGS_STATIC := -linkmode external -extldflags --static-pie
+	endif
+endif
+# Enable static PIE binaries on supported platforms.
+GO_BUILD_STATIC := $(GO) build -trimpath $(GO_BUILDMODE_STATIC) \
+	$(EXTRA_FLAGS) -tags "$(BUILDTAGS) netgo osusergo" \
+	-ldflags "$(LDFLAGS_COMMON) $(LDFLAGS_STATIC) $(EXTRA_LDFLAGS)"
 
 GPG_KEYID ?= asarai@suse.de
+
+# Some targets need cgo, which is disabled by default when cross compiling.
+# Enable cgo explicitly for those.
+# Both runc and libcontainer/integration need libcontainer/nsenter.
+runc static localunittest: export CGO_ENABLED=1
+# seccompagent needs libseccomp (when seccomp build tag is set).
+ifneq (,$(filter $(BUILDTAGS),seccomp))
+seccompagent: export CGO_ENABLED=1
+endif
 
 .DEFAULT: runc
 
@@ -40,7 +68,7 @@
 static:
 	$(GO_BUILD_STATIC) -o runc .
 
-releaseall: RELEASE_ARGS := "-a arm64 -a armel -a armhf -a ppc64le -a s390x"
+releaseall: RELEASE_ARGS := "-a arm64 -a armel -a armhf -a ppc64le -a riscv64 -a s390x"
 releaseall: release
 
 release: runcimage

=== debian/changelog ===
runc (1.1.12+ds1-ok2) nile; urgency=medium

  * SECURITY UPDATE

 -- liubo01 <liubo01@kylinos.cn>  Tue, 05 Nov 2024 09:24:57 +0800

runc (1.1.12+ds1-ok1) nile; urgency=medium

  * Build for openKylin.

 -- Luoyaoming <Luoyaoming@kylinos.cn>  Tue, 30 Apr 2024 18:13:03 +0800

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: optional
 Standards-Version: 4.6.2
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: openKylin Developers <packaging@lists.openkylin.top>
 XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
 Uploaders: Alexandre Viau <aviau@debian.org>,
            Dmitry Smirnov <onlyjob@debian.org>,
@@ -29,12 +29,26 @@
                golang-gocapability-dev (>= 0.0+git20200815~),
                golang-golang-x-net-dev,
                golang-google-protobuf-dev,
+               pkgconf,
 Homepage: https://github.com/opencontainers/runc
 Vcs-Git: https://salsa.debian.org/go-team/packages/runc.git
 Vcs-Browser: https://salsa.debian.org/go-team/packages/runc
 XS-Go-Import-Path: github.com/opencontainers/runc
 Rules-Requires-Root: no
 Testsuite: autopkgtest-pkg-go
+
+Package: runc
+Build-Profiles: <pkg.runc.with-bin>
+Architecture: any
+Depends: ${misc:Depends},
+         ${shlibs:Depends},
+Built-Using: ${misc:Built-Using},
+Recommends: criu,
+            ${misc:Recommends},
+Description: Open Container Project - runtime
+ "runc" is a command line client for running applications packaged according
+ to the Open Container Format (OCF) and is a compliant implementation of
+ the Open Container Project specification.
 
 Package: golang-github-opencontainers-runc-dev
 Architecture: all
